<?php

namespace DsbNext\Controllers;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;

class DashboardGOController{
    
    protected $crudService;
    
    public function __construct($connection, $environment, $util, $crudService) {
        $this->crudService	= $crudService;
        $this->connection      = $connection;
        $this->environment     = $environment;
        $this->util            = $util;
    }
    
    public function costAnalysisAccumulatedGO(Request\Filter $request, Response $response) {
        $params = ['CDOPERADOR', 'DTPROCESSA', 'NRORG'];
        $conditions = $this->util->prepareConditions($params);
        $data = $this->crudService->getFilteredDataSet('costAnalysisAccumulatedGO', $conditions)->getRows();
		$response->addDataSet(new DataSet("costAnalysisAccumulatedGO", $data));
    }
    
    public function operationalResultGO(Request\Filter $request, Response $response) {
        $params = ['CDOPERADOR', 'DTPROCESSA', 'NRORG'];
        $conditions = $this->util->prepareConditions($params);
        $data = $this->crudService->getFilteredDataSet('operationalResultGO', $conditions)->getRows();
		$response->addDataSet(new DataSet("operationalResultGO", $data));
    }
    
    public function adjustmentPercentConsumptionGO(Request\Filter $request, Response $response) {
        $params = ['CDOPERADOR', 'DTPROCESSA', 'NRORG'];
        $conditions = $this->util->prepareConditions($params);
        $data = $this->crudService->getFilteredDataSet('adjustmentPercentConsumptionGO', $conditions)->getRows();
		$response->addDataSet(new DataSet("adjustmentPercentConsumptionGO", $data));
    }
    
    public function daysOfStockGO(Request\Filter $request, Response $response) {
        $params = ['CDOPERADOR'];
        $conditions = $this->util->prepareConditions($params);
        array_push($conditions, 
            array(
                "columnName" => "DATAINI",
                "operator"   => '=',
                "value"      => $currentTime = $this->environment->getCurrentTime()->format("01/m/Y")
            ),
            array(
                "columnName" => "DATAFIN",
                "operator"   => '=',
                "value"      => $currentTime = $this->environment->getCurrentTime()->format("t/m/Y")
            )
        );
        $data = $this->crudService->getFilteredDataSet('daysOfStockGO', $conditions)->getRows();
		$response->addDataSet(new DataSet("daysOfStockGO", $data));
    }
    
    public function costAnalysisAccumulatedGrid(Request\Filter $request, Response $response) {
        $params = ['CDOPERADOR', 'DTPROCESSA', 'NRORG'];
        $conditions = $this->util->prepareConditions($params);
        $data = $this->crudService->getFilteredDataSet('costAnalysisAccumulatedGO', $conditions)->getRows();
		$response->addDataSet(new DataSet("costAnalysisAccumulatedGrid", $data));
    }
    
    public function adjustmentPercentConsumptionGrid(Request\Filter $request, Response $response) {
        $params = ['CDOPERADOR', 'DTPROCESSA', 'NRORG'];
        $conditions = $this->util->prepareConditions($params);
        $data = $this->crudService->getFilteredDataSet('adjustmentPercentConsumptionGO', $conditions)->getRows();
		$response->addDataSet(new DataSet("adjustmentPercentConsumptionGrid", $data));
    }
}