import { FormatterParserProvider } from '@zeedhi/core';

export class Formatting {
  formatValue(type: string, value: any): any {
    let valueReturn = '';
    
    if (value !== undefined) {
      const formatterFn = FormatterParserProvider.getFormatter('ZdNumber');

      switch (type) {
        case 'float':
          if ((value || value === 0) && (value < 10000000000000 && value > -10000000000000)) {
            valueReturn = formatterFn(value);
          } else {
            valueReturn = '-';
          }
          break;
        case 'number':
          valueReturn = value || value === 0 ? value.toFixed(0) : '';
          break;
        case 'date': valueReturn = value;
          break;
        default: valueReturn = value;
      }
    } else {
      valueReturn = value;
    }
    return valueReturn;
  }
  
  formatFilter(obj: any): any {
    const objReturn = Object.entries(obj).map(([name, value]) => ({
      name,
      operator: '=',
      value,
    }));
    
    return objReturn;
  }
}
